---
title: Element.scrollIntoViewIfNeeded()
slug: Web/API/Element/scrollIntoViewIfNeeded
tags:
  - API
  - DOM
  - Element
  - Method
  - Non-standard
  - Reference
---
<div>{{APIRef("DOM")}}{{Non-standard_header}}</div>

<p>The <code><strong>Element.scrollIntoViewIfNeeded()</strong></code> method scrolls the current element into the visible area of the browser window if it's not already within the visible area of the browser window. If the element is already within the visible area of the browser window, then no scrolling takes place. This method is a proprietary variation of the standard <a href="/en-US/docs/Web/API/Element/scrollIntoView"><code>Element.scrollIntoView()</code></a> method.</p>

<h2 id="Syntax">Syntax</h2>

<p>TODO</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em><code>opt_center</code></em></dt>
 <dd>Is an optional {{jsxref("Boolean")}} value with a default value of <code>true</code>:
 <ul>
  <li>If <code>true</code>, the element will be aligned so it is centered within the visible area of the scrollable ancestor.</li>
  <li>If <code>false</code>, the element will be aligned to the nearest edge of the visible area of the scrollable ancestor. Depending on which edge of the visible area is closest to the element, either the top of the element will be aligned to the top edge of the visible area, or the bottom edge of the element will be aligned to the bottom edge of the visible area.</li>
 </ul>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var element = document.getElementById("my-el");

element.scrollIntoViewIfNeeded();
element.scrollIntoViewIfNeeded(true); // Centers the element in the visible area
</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any specification. This is a proprietary, WebKit-specific method.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.scrollIntoViewIfNeeded")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.w3.org/Bugs/Public/show_bug.cgi?id=17152">W3C CSSOM bug 17152: Support centering an element when scrolling into view.</a> (feature request for a standardized equivalent to <code>scrollIntoViewIfNeeded</code>)</li>
</ul>
